# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
name = "kira_kv_engine"
version = "0.2.1"
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "KV-storage engine based on minimal perfect hash functions with hybrid indexing (+PGM Index) for Rust"
homepage = "https://github.com/ARyaskov/kira_kv_engine"
documentation = "https://docs.rs/kira_kv_engine"
readme = "README.md"
keywords = [
    "hashing",
    "perfect-hash",
    "key-value",
    "storage",
    "pgm",
]
categories = [
    "data-structures",
    "database",
]
license = "MIT"
repository = "https://github.com/ARyaskov/kira_kv_engine"

[features]
avx512 = ["simd"]
default = [
    "serde",
    "simd",
    "parallel",
    "pgm",
]
parallel = ["dep:rayon"]
pgm = []
serde = [
    "dep:serde",
    "dep:bincode",
]
simd = []
unsafe_optimizations = []

[lib]
name = "kira_kv_engine"
path = "src/lib.rs"

[[example]]
name = "million_build"
path = "examples/million_build.rs"

[dependencies.bincode]
version = "1"
optional = true

[dependencies.hashbrown]
version = "0.14"

[dependencies.rand]
version = "0.8"

[dependencies.rayon]
version = "1.8"
optional = true

[dependencies.serde]
version = "1"
features = ["derive"]
optional = true

[dependencies.thiserror]
version = "1"

[dependencies.wyhash]
version = "0.6"

[dev-dependencies.criterion]
version = "0.5"

[dev-dependencies.rand]
version = "0.8"

[profile.bench]
debug = 2
inherits = "release"

[profile.release]
opt-level = 3
lto = "fat"
codegen-units = 1
debug-assertions = false
panic = "abort"
overflow-checks = false

[profile.release-extreme]
opt-level = "z"
lto = "fat"
overflow-checks = false
inherits = "release"
strip = true
